<!--
    Used to show feedback messages.

    Usage :

      Template :

        <FeedBackMessage ref="feedBackMessage" with-border="true"/>
        <FeedBackMessage ref="feedBackMessage"/>

      Script :

         @Ref() private readonly feedBackMessage!: FeedBackMessage

         this.feedBackMessage.reset() // Clears the message
         this.feedBackMessage.fail("message") // Shows a message in red
         this.feedBackMessage.success("message") // Shows a message in green

-->

<template>
  <div>
    <v-card-text v-if="withBorder" class="error_container">
      <p class="error-frame-border text-center v-size--small" v-if="message.message">
        {{ message.message }}
      </p>
    </v-card-text>
    <v-flex v-else>
      <div v-if="message.type !== 'none'"
           :class="{'success-frame' :message.type === 'success', 'error-frame': message.type === 'failure'}">
        {{ message.message }}
      </div>
    </v-flex>
  </div>
</template>

<style scoped>
.v-size--small {
  font-size: 0.7em;
}

.error_container {
  height: 20px;
}

.error-frame-border {
  outline: 1px solid #EE0000;
  color: red;
}

.error-frame {
  color: red;
}

.success-frame {
  color: green;
}
</style>

<script lang="ts">
import {Component, Prop, Vue} from "vue-property-decorator"

interface Message {
  message: string,
  type: string
}

@Component
export default class FeedBackMessage extends Vue {

  @Prop({default: false}) private readonly withBorder!: string

  private message: Message = {message: "", type: "none"}

  public fail(msg: string) {
    this.message.message = this.$t(msg).toString()
    this.message.type = "failure"
  }

  public success(msg: string) {
    this.message.message = this.$t(msg).toString()
    this.message.type = "success"
  }

  public reset() {
    this.message = {message: "", type: "none"}
  }

}
</script>
